;;;; Recursive Benchmark from The Computer Language Shootout
;;;; Written by Aaron Hsu
;;;; Designed for MIT Scheme

(declare (usual-integrations))
(load-option 'format)

(let ()

(define (ack x y)
  (cond ((zero? x)
         (+ y 1))
        ((zero? y)
         (ack (- x 1)
              1))
        (else (ack (- x 1)
                   (ack x
                        (- y 1))))))

;(define (fib n)
;  (if (< n 2)
;      1
;      (+ (fib (- n 2))
;         (fib (- n 1)))))

(define (fix:fib n)
  (if (fix:< n 2)
      1
      (fix:+ (fix:fib (fix:- n 2))
           (fix:fib (fix:- n 1)))))

(define (flo:fib n)
  (if (flo:< n 2.0)
      1.0
      (flo:+ (flo:fib (flo:- n 2.0))
           (flo:fib (flo:- n 1.0)))))

;(define (tak x y z)
;  (if (< y x)
;      (tak (tak (- x 1)
;                y z)
;           (tak (- y 1)
;                z x)
;           (tak (- z 1)
;                x y))
;      z))

(define (fix:tak x y z)
  (if (fix:< y x)
      (fix:tak (fix:tak (fix:- x 1)
                      y z)
              (fix:tak (fix:- y 1)
                      z x)
              (fix:tak (fix:- z 1)
                      x y))
      z))

(define (flo:tak x y z)
  (if (flo:< y x)
      (flo:tak (flo:tak (flo:- x 1.0)
                      y z)
              (flo:tak (flo:- y 1.0)
                      z x)
              (flo:tak (flo:- z 1.0)
                      x y))
      z))

(define (run-benchmark n)
  (format #t "Ack(3, ~a): ~a~%" n (ack 3 n))
  (set! n (- n 1))
  (format #t "Fib(~a): ~a~%" (+ 28.0 n) (flo:fib (+ 28.0 n)))
  (format #t "Tak(~a, ~a, ~a): ~a~%" 
          (* 3 n) (* 2 n) n (fix:tak (* 3 n) (* 2 n) n))
  (format #t "Fib(~a): ~a~%" 3 (fix:fib 3))
  (format #t "Fib(3.0,2.0,1.0): ~a~%" (flo:tak 3.0 2.0 1.0)))

(run-benchmark 11)

)

(exit)
