;;;; Recursive Benchmark from The Computer Language Shootout
;;;; Written by Aaron Hsu
;;;; Designed for Chez Scheme

(eval-when (compile) (optimize-level 3))

(let ()

(define (ack x y)
  (cond ((zero? x)
         (+ y 1))
        ((zero? y)
         (ack (- x 1)
              1))
        (else (ack (- x 1)
                   (ack x
                        (- y 1))))))

;(define (fib n)
;  (if (< n 2)
;      1
;      (+ (fib (- n 2))
;         (fib (- n 1)))))

(define (fx-fib n)
  (if (fx< n 2)
      1
      (fx+ (fx-fib (fx- n 2))
           (fx-fib (fx- n 1)))))

(define (fl-fib n)
  (if (fl< n 2.0)
      1.0
      (fl+ (fl-fib (fl- n 2.0))
           (fl-fib (fl- n 1.0)))))

;(define (tak x y z)
;  (if (< y x)
;      (tak (tak (- x 1)
;                y z)
;           (tak (- y 1)
;                z x)
;           (tak (- z 1)
;                x y))
;      z))

(define (fx-tak x y z)
  (if (fx< y x)
      (fx-tak (fx-tak (fx- x 1)
                      y z)
              (fx-tak (fx- y 1)
                      z x)
              (fx-tak (fx- z 1)
                      x y))
      z))

(define (fl-tak x y z)
  (if (fl< y x)
      (fl-tak (fl-tak (fl- x 1.0)
                      y z)
              (fl-tak (fl- y 1.0)
                      z x)
              (fl-tak (fl- z 1.0)
                      x y))
      z))

(define (run-benchmark n)
  (format #t "Ack(3, ~a): ~a~%" n (ack 3 n))
  (set! n (- n 1))
  (format #t "Fib(~,1F): ~,1F~%" (+ 28.0 n) (fl-fib (+ 28.0 n)))
  (format #t "Tak(~a, ~a, ~a): ~a~%" 
          (* 3 n) (* 2 n) n (fx-tak (* 3 n) (* 2 n) n))
  (format #t "Fib(~a): ~a~%" 3 (fx-fib 3))
  (format #t "Tak(3.0,2.0,1.0): ~,1F~%" (fl-tak 3.0 2.0 1.0)))

(run-benchmark 11)

)

(exit)
